<template>
  <div id="navbar" class="navbar" :style="{'display': displayNav}">
    <hamburger
      id="hamburger-container"
      :is-active="sidebar.opened"
      class="hamburger-container"
      @toggleClick="toggleSideBar"
    />

    <breadcrumb id="breadcrumb-container" class="breadcrumb-container" />

    <div class="right-menu">
      <template v-if="device!=='mobile'">
        <error-log class="errLog-container right-menu-item hover-effect" />
      </template>

      <div class="right-menu-item">
        <div>
          <div style="font-size: 10pt; display: block; line-height: 1.3em; padding: 8px">
            <div><strong style="float:right">{{ name }}</strong><br></div>{{ costume(_.get(user, 'roles_active.label')) }}
          </div>
        </div>
      </div>
      <el-dropdown class="avatar-container right-menu-item hover-effect" trigger="click">
        <div class="avatar-wrapper">
          <img alt="image user-avatar" :src="avatar" class="user-avatar">
          <em class="el-icon-caret-bottom" />
        </div>
        <el-dropdown-menu slot="dropdown">
          <router-link to="/profile">
            <el-dropdown-item>{{ $t('navbar.profile') }}</el-dropdown-item>
          </router-link>
          <el-dropdown-item divided>
            <router-link to="/edit-profile">
              <span style="display:block;">{{ $t('navbar.profile-edit') }}</span>
            </router-link>
          </el-dropdown-item>
          <el-dropdown-item divided>
            <span style="display:block;" @click="logout">{{ $t('navbar.logOut') }}</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import Breadcrumb from '@/components/Breadcrumb'
import Hamburger from '@/components/Hamburger'
import ErrorLog from '@/components/ErrorLog'

export default {
  components: {
    Breadcrumb,
    Hamburger,
    ErrorLog
  },
  data() {
    return {
      displayNav: 'block',
      QNA: 'question-answer',
      MOBILE: 'mobile'
    }
  },
  computed: {
    ...mapGetters(['sidebar', 'name', 'avatar', 'device', 'user', 'roles_active'])
  },
  watch: {
    $route(to, from) {
      if ((to.name === this.QNA) && (this.device === this.MOBILE)) {
        this.displayNav = 'none'
      } else {
        this.displayNav = 'block'
      }
    }
  },
  methods: {
    toggleSideBar() {
      this.$store.dispatch('app/toggleSideBar')
    },
    async logout() {
      await this.$store.dispatch('user/logout')
      this.$router.push(`/login`)
    },
    costume(value) {
      if (value === this.$t('label.roles-staff-kel')) {
        return this.$t('label.roles-admin') + ' ' + this.user.kabkota.name + ' ' + this.$t('label.area-kec') + ' ' + this.user.kecamatan.name + ' ' + this.$t('label.area-kel') + ' ' + this.user.kelurahan.name
      } else if (value === this.$t('label.roles-staff-kec')) {
        return this.$t('label.roles-admin') + ' ' + this.user.kabkota.name + ' ' + this.$t('label.area-kec') + ' ' + this.user.kecamatan.name
      } else if (value === this.$t('label.roles-staff-kabkota')) {
        return this.$t('label.roles-admin') + ' ' + this.user.kabkota.name
      } else if (value === this.$t('label.roles-staff-province')) {
        return this.$t('label.roles-admin-province')
      } else {
        return this.$t('label.roles-administrator')
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.navbar {
  height: 50px;
  display: block;
  overflow: hidden;
  position: relative;
  background: rgba(249, 249, 249, 0.9);
  box-shadow: 0 1px 4px rgba(0, 21, 41, 0.08);

  .hamburger-container {
    line-height: 46px;
    height: 100%;
    float: left;
    cursor: pointer;
    transition: background 0.3s;
    -webkit-tap-highlight-color: transparent;

    &:hover {
      background: rgba(0, 0, 0, 0.025);
    }
  }

  .breadcrumb-container {
    float: left;
  }

  .errLog-container {
    display: inline-block;
    vertical-align: top;
  }

  .right-menu {
    float: right;
    height: 100%;
    line-height: 50px;

    &:focus {
      outline: none;
    }

    .right-menu-item {
      display: inline-block;
      padding: 0 8px;
      height: 100%;
      font-size: 18px;
      color: #5a5e66;
      vertical-align: text-bottom;

      &.hover-effect {
        cursor: pointer;
        transition: background 0.3s;

        &:hover {
          background: rgba(0, 0, 0, 0.025);
        }
      }
    }

    .avatar-container {
      margin-right: 30px;

      .avatar-wrapper {
        margin-top: 5px;
        position: relative;

        .user-avatar {
          cursor: pointer;
          width: 40px;
          height: 40px;
          border-radius: 10px;
        }

        .el-icon-caret-bottom {
          cursor: pointer;
          position: absolute;
          right: -20px;
          top: 25px;
          font-size: 12px;
        }
      }
    }
  }
}
</style>
